* Branching

$eolcom //
$include header.inc // read data which may be changed by the user

set is
    ifrac(is)
    v
    isv(is,v)
    same(v,v)
    differ(v,v);

parameters
   ypar(is)           fractional y variables;

$gdxin data
$load v

$gdxin cols
$load is isv

$gdxin %minfo%
$load ypar same differ

* TM declarations
Sets
     nodes            nodes  /1*%nrnodes%/
     cur(nodes)       current node
     newnodes(nodes)  nodes created by branching
     lastnode(nodes)  overall last node;

* load data from tree manager
$gdxin %binfoin%
$load cur lastnode

alias (v,w);

ifrac(is) = ypar(is);
File fx file operation handle;

* maximum infeasibility branching
abort$(card(ifrac)=0) 'nothing to branch on';

ypar(ifrac) = abs(ypar(ifrac) - 0.5);
scalar maxinf; maxinf = smin(ifrac, ypar(ifrac));
abort$(maxinf>=0.5) 'branching value should be between 0 and 0.5', maxinf;

set vv(v), ww(v); vv(v) = no;
alias (ifrac,i1,i2);

loop(i1$(card(vv)=0 and ypar(i1)=maxinf),
  loop((v,i2)$(isv(i1,v) and isv(i2,v) and card(vv)=0),
    loop(w$((isv(i1,w) xor isv(i2,w)) and card(vv)=0),
      vv(v) = yes; ww(w) = yes)));

lastnode(nodes)        = lastnode(nodes-1);         // advance last node
newnodes(lastnode)     = yes;                       // store new node
differ(vv,ww)          = yes;

* write gdx file for node
loop(lastnode(nodes), put_utility fx 'gdxout' / nodes.tl:0'.gdx'); // dynamic gdx file name
execute_unload differ, same;
differ(vv,ww)          = no;

lastnode(nodes)        = lastnode(nodes-1);         // advance last node
newnodes(lastnode)     = yes;                       // store new node
same(vv,ww)            = yes;

* write gdx file for node
loop(lastnode(nodes), put_utility fx 'gdxout' / nodes.tl:0'.gdx'); // dynamic gdx file name
execute_unload differ, same;

execute_unload '%binfo%', newnodes, lastnode;
