$eolcom //
$include header.inc

set v
    e(v,v)
    same(v,v)
    differ(v,v);

$gdxin data
$load v e

$gdxin branch
$load same differ

Equation
     defcover(v) cover constraint;

alias (v,w);

$gdxin bchout
$load defcover

* Pricing problem - Weighted independend set model
Variable  z, x(v) new set;
Binary variable x;

Equation defobj, defedge, defsame, defdiffer;

defobj..                 z =e= sum(v, defcover.m(v)*x(v));
defedge(e(v,w))..        x(v) + x(w) =l= 1;
defsame(same(v,w))..     x(v) =e= x(w);
defdiffer(differ(v,w)).. x(v) =e= 1-x(w);

model imax / defobj, defedge, defsame, defdiffer /;

option mip=cplex;
$onecho > cplex.o16
solnpool solnpool.gdx
solnpoolreplace 2
*solnpoolgap 0.1
solnpoolpop 2
SolnPoolIntensity 3
populatelim 20                  
$offecho
imax.optfile=16;

solve imax using mip max z;

file fsoln;
Sets soln           possible solutions in the solution pool /file1*file1000/
     solnpool(soln) actual solutions;

Set cols /1*20/, cc(cols) /1/;
Parameter
    numcols  number of columns generated / 0 /
*  level, lower, upper, type: 0 cont, 1 bin, 2 int, 3 semicont, 4 semiint
    col_info(cols,*)   Column information
    obj_c(cols), defcover_c(cols,v) Matrix entries;

execute_load 'solnpool.gdx', solnpool=index;
loop(solnpool(soln),
  put_utility fsoln 'gdxin' / solnpool.te(soln);
  execute_loadpoint;
* independent set that might improve the master model found?
  if(z.l > 1+0.001,
     numcols          = numcols + 1;
     obj_c(cc)        = 1;
     defcover_c(cc,v) = round(x.l(v));
     col_info(cc,'lower') = 0;
     col_info(cc,'upper') = 1;
     col_info(cc,'type')  = 1;
     cc(cols)             = cc(cols-1); // advance column
  );
);

$exit


*execute 'pause';
